﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace EvolutStudio
{
    namespace tinysAPI
    {
        namespace BaseClasses
        {
            abstract public class BaseClassComponent : BaseClass
            {
                // reference to the currect index in ther components array list in the parent view
                protected int _ComponentsArrayIndex = 0;

                #region Interface Functions

                // interface function for controller to notify the view for succeeded model validation
                abstract public void ValidationSucceeded(string notification);

                // interface function for controller to notify the view for failed model validation
                abstract public void ValidationFailed(string notification);

                // interface function for initialization
                abstract public void Init();

                #endregion

                #region Unity Events

                // Use this for initialization
                void Start()
                {
                    Init();
                }

                #endregion
            }
        }
    }
}
